/**
 * @title 不同颜色的 Checkbox
 * @description `colors`参数控制背景色
 */

import React, { Component } from 'react';
import {KeyCode} from 'tinper-bee-core';
import Checkbox from '../../src';

class Demo2 extends Component {
	constructor(props){
		super(props);
		this.state = {
			focusIndex: -1
		}
	}
	componentDidMount(){
		this.checkboxGroup = document.getElementById('demo-checkbox');
	}
	focusOne = () => {
		this.checkboxGroup.childNodes[0].focus();
		this.setState({
			focusIndex: 0
		})
	}
	handleKeyDown = (e) => {
		if(e.keyCode !== KeyCode.SPACE){
			e.stopPropagation();
			e.preventDefault();
		}
		let { focusIndex } = this.state;
		let newFocusIndex = -1;
		const min = 0; const max = this.checkboxGroup.childNodes.length - 1;
		if(e.keyCode == KeyCode.DOWN){
			newFocusIndex = ++focusIndex <= max ? focusIndex++ : max;
			this.checkboxGroup.childNodes[newFocusIndex].focus();
		} else if (e.keyCode == KeyCode.UP){
			newFocusIndex = --focusIndex >= min ? focusIndex-- : min;
			this.checkboxGroup.childNodes[newFocusIndex].focus();
		}
		this.setState({
			focusIndex: newFocusIndex
		})
	}
	render(){
		return (
			<div>
				<button onClick={this.focusOne}>focus</button>
				<div id="demo-checkbox" onKeyDown={this.handleKeyDown}>
					<Checkbox colors="primary">primary</Checkbox>
					<Checkbox colors="success">success</Checkbox>
					<Checkbox colors="info">info</Checkbox>
					<Checkbox colors="danger">danger</Checkbox>
					<Checkbox colors="warning">warning</Checkbox>
					<Checkbox colors="dark">dark</Checkbox>
				</div>
			</div>
		)
	}
}
export default Demo2;
